commit 124baaf6c1e8b89ce7d9f586274c5389e0620d78
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Tue Jul 23 15:51:29 2024 +0530

    PS-9301 Fixes HEAP-USE-AFTER-FREE errors sql/item.cc
    
    https://perconadev.atlassian.net/browse/PS-9301
    
    Bug#36543458 mysql/mysql-server@76dd59535fb
    Bug#33142654 mysql/mysql-server@227ffcd4dad
    
    Same patch as for the original
    Bug#33142654 THE SECOND HEAP-USE-AFTER-FREE ISSUE OF MYSQL SERVER
    but for MacOS lower_case_table_name
    
    The fix is to test the QT_NO_TABLE flag before accessing table_name.
    
    Change-Id: I0b613f18663723e3e6a4c2b305641883000261ef
    (cherry picked from commit ec0e2c54bb1002ec350b505968873581e29b6b3f)
    (cherry picked from commit d86e0a201e0bcdf479d0afcd6fef1aa13135ae06)
    
    Bug #33142654 THE SECOND HEAP-USE-AFTER-FREE ISSUE OF MYSQL SERVER
    
    As part of optimizer trace in the range optimizer, we try to print a
    view definition, and this may access uninitialized data.
    
    This patch
    Bug#21929967 GCOLS: GCOL VALUE CHANGES WHEN SESSION CHANGES SQL_MODE
    introduced QT_NO_TABLE for printing identifiers.
    
    The fix is to test the QT_NO_TABLE flag before accessing table_name.
    
    Change-Id: I976cc2464e289851972c1151a122573f6f45f5ea

diff --git a/sql/item.cc b/sql/item.cc
index aac5cf5ff9a..012c140411f 100644
--- a/sql/item.cc
+++ b/sql/item.cc
@@ -2902,13 +2902,13 @@ void Item_ident::print(String *str, enum_query_type query_type,
       // mode '2' does not apply to aliases:
       (lower_case_table_names == 2 && !alias_name_used()))
   {
-    if (table_name_arg && table_name_arg[0])
+    if (!(query_type & QT_NO_TABLE) && table_name_arg && table_name_arg[0])
     {
       my_stpcpy(t_name_buff, table_name_arg);
       my_casedn_str(files_charset_info, t_name_buff);
       t_name= t_name_buff;
     }
-    if (db_name_arg && db_name_arg[0])
+    if (!(query_type & QT_NO_DB) && db_name_arg && db_name_arg[0])
     {
       my_stpcpy(d_name_buff, db_name_arg);
       my_casedn_str(files_charset_info, d_name_buff);
@@ -2924,8 +2924,8 @@ void Item_ident::print(String *str, enum_query_type query_type,
     return;
   }
 
-  if (db_name_arg && db_name_arg[0] &&
-      !(query_type & QT_NO_DB) &&
+  if (!(query_type & QT_NO_DB) &&
+      db_name_arg && db_name_arg[0] &&
       !alias_name_used())
   {
     const size_t d_name_len= strlen(d_name);
@@ -2936,7 +2936,7 @@ void Item_ident::print(String *str, enum_query_type query_type,
       str->append('.');
     }
   }
-  if (table_name_arg[0] && !(query_type & QT_NO_TABLE))
+  if (!(query_type & QT_NO_TABLE) && table_name_arg[0])
   {
     append_identifier(thd, str, t_name, strlen(t_name));
     str->append('.');

